﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;

using FirebirdSql.Data.FirebirdClient;


namespace DbsConsole
{
    public partial class Form1 : Form
    {
        Dbs _dbs;
        DataTable _dtDataBase;
        DataTable _dtTablenames;
        bool _bStart;
        int _fontsize = 9;


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            _dbs = new Dbs();
            setGUI();

        }

        private void setGUI()
        {
            splitContainer3.Dock = DockStyle.Fill;
            ESQL.Dock = DockStyle.Fill;
            splitContainer1.Dock = DockStyle.Fill;
            splitContainer2.Dock = DockStyle.Fill;
            listBox1.Dock = DockStyle.Fill;
            listBox2.Dock = DockStyle.Fill;
            splitContainer1.SplitterDistance = 200;
            Grid1.Dock = DockStyle.Fill;

            Grid1.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.None;
            Grid1.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.None;
            Grid1.SelectionMode = DataGridViewSelectionMode.FullRowSelect;
            

            Grid1.AutoSize = true;
            //Grid1.AllowUserToAddRows = false;
            //Grid1.AllowUserToDeleteRows = false;
            Grid1.MultiSelect = false;
        } // setGUI

        private void BnOpenDataBase_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "Datenbankdateien (*.fdb,gdb)|*.fdb;*.gdb|Alle Dateien (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;// zählt von 1 !
            openFileDialog1.DefaultExt = ".fdb";
            openFileDialog1.InitialDirectory = Environment.CurrentDirectory;
            openFileDialog1.Multiselect = false;
            openFileDialog1.RestoreDirectory = true;
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                // if (BnStart.Enabled) _dbs.Close();  // geschieht automatisch
                string sFilename = openFileDialog1.FileName.ToString();                                
                _dbs.setDbs(sFilename);

                BnStart.Enabled = true;
                MnRunSQL.Enabled = true;
                MnExportErgebnis.Enabled = true;
                MnSaveErgebnisseToFile.Enabled = true;
                _bStart = true;
                setTables();
                _bStart = false;
                listBox2.Items.Clear();
                setListBoxSize();
            }
        }

        public DataTable getTables()
        {
            string[] filter = new string[4];
            filter[0] = "dbo"; //  null;
            filter[1] = null;
            filter[2] = null;
            filter[3] = null;
            DataTable dt;
            dt = _dbs.GetSchema("Tables", filter);            
            return dt;
        }
        /*
        Alternative Varianten
CharacterSets
CheckConstraints
CheckConstraintsByTable
Collations
ColumnsPrivilegs
Columns
DataTypes
Domains
 ForeignsKey
Functions
 Generators
Indexes
MetaDataCollections
PrimaryKeys
ProcedureParameters
ProcedurePrivileges
Procedures
Restriction
Roles
TableConstraints
TablePrivileges
Tables
Triggers
UniqueKeys
ViewColumnUsage
ViewPrivileges
Views

         */

        private void setTables()
        {
            // _dtDataBase = _Fbcnn.GetSchema("Tables", new string[] { null, null, null, "TABLE" });

            _dtDataBase = getTables();
            listBox1.Items.Clear();
            for (int row = 0; row < _dtDataBase.Rows.Count; row++)
            {
                string sTabletyp = (string)_dtDataBase.Rows[row][3];
                if (sTabletyp.Equals("TABLE"))
                    listBox1.Items.Add(_dtDataBase.Rows[row][2].ToString());
            }
            listBox1.SelectedIndex = 0;
        }

        private void newToolStripButton_Click(object sender, EventArgs e)
        {
            ESQL.Text = "";
        }

        private void BnOpen_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "Textdateien (*.txt)|*.txt|Alle Dateien (*.*)|*.*";
            openFileDialog1.FilterIndex = 3;// zählt von 1 !
            openFileDialog1.DefaultExt = ".txt";
            openFileDialog1.InitialDirectory = Environment.CurrentDirectory;
            openFileDialog1.Multiselect = false;
            openFileDialog1.RestoreDirectory = true;
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string sFilename = openFileDialog1.FileName.ToString();
                loadFile(sFilename);
            }
        }

        private void loadFile(string sFilename)
        {
            string sStr;
            FileStream oFile = new FileStream(sFilename, FileMode.Open);
            StreamReader inStream = new StreamReader(oFile);
            sStr = inStream.ReadToEnd();
            ESQL.Text = sStr;
            inStream.Close();
            oFile.Close();
        }  // loadFile





        private void BnStart_Click(object sender, EventArgs e)
        {
            DateTime Time1, Time2;
            string sSQL = ESQL.Text.Trim();
            if (sSQL.Equals("")) return;

            Text = Text + "a";
            DataTable dt1 = _dbs.getDBSData(sSQL);
            Text = Text + "b";
            LAnzahl.Text = "Anzahl: " + dt1.Rows.Count.ToString() + " ";
            Text = Text + "c";
            Grid1.Visible = false;

            
            Grid1.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.None;
            Grid1.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.None;
            Time1 = DateTime.Now;
            Grid1.DataSource = dt1;
            
            Grid1.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.ColumnHeader;
            Grid1.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.None;
            Time2 = DateTime.Now;
            
            Grid1.Visible = true;
            Grid1.AllowUserToAddRows=false;
            Grid1.AllowUserToDeleteRows=false;
            Grid1.AllowUserToOrderColumns=true;
            TimeSpan duration1 = Time2 - Time1;
            Text = "Zeit: " + duration1;
        }

        private void listBox1_DoubleClick(object sender, EventArgs e)
        {
            int i = listBox1.SelectedIndex;
            if ((!_bStart) && (i >= 0))
            {
                string sTable = (string)listBox1.SelectedItem;
                Clipboard.SetText(" " + sTable);
                ESQL.Paste();
            }
        }

        private void listBox2_DoubleClick(object sender, EventArgs e)
        {
            int i = listBox2.SelectedIndex;
            if ((!_bStart) && (i >= 0))
            {
                string sAttribname = (string)_dtTablenames.Rows[i][3];
                Clipboard.SetText(" " + sAttribname);
                ESQL.Paste();
            }
        }

        public DataTable getDataTyps(string sTable)
        {
            string[] filter = new string[4];  // Schränkt das Ergebnis ein
            filter[0] = null; // Katalog  TABLE_CATALOG     z. B. dbo
            filter[1] = null; // Besitzer  TABLE_SCHEMA
            filter[2] = sTable;  // Tabellenname
            filter[3] = null;  // TABLE_TYPE  (System oder 
            DataTable dt;
            dt = new DataTable("RELATIONS");
            // dt = _cnn.GetSchema("Columns");  // liefert alle Spalten
            dt = _dbs.GetSchema("Columns", filter);
            return dt;
        }


        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int i = listBox1.SelectedIndex;
            if ((!_bStart) && (i >= 0))
            {
                string sTable = (string)listBox1.SelectedItem;
                _dtTablenames = getDataTyps(sTable);  // getDataTyps(string sTable)
                listBox2.Items.Clear();
                for (int row = 0; row < _dtTablenames.Rows.Count; row++)
                {
                    string sAttribname = (string)_dtTablenames.Rows[row][3];
                    string sFormat = (string)_dtTablenames.Rows[row][4];
                    listBox2.Items.Add(sAttribname + " (" + sFormat + ")");
                }
            }
        }

        

        private void MnClose_Click(object sender, EventArgs e)
        {
            Close();
        }



        private void MnTables_Click(object sender, EventArgs e)
        {
            Grid1.DataSource = getTables();
        }

        public DataTable getTableProperties(string sTable, string sProperty)
        {
            string[] filter = new string[4];
            filter[0] = null;
            filter[1] = null;
            filter[2] = sTable;
            filter[3] = null;
            DataTable dt;
            dt = new DataTable("RELATIONS");
            dt = _dbs.GetSchema(sProperty, filter);  // TRIGGERS
            return dt;
        }

        private void setTableProperties(String sProperty)
        {
            int i = listBox1.SelectedIndex;
            if ((!_bStart) && (i >= 0))
            {
                string sTable = (string)listBox1.SelectedItem;
                DataTable dt = getTableProperties(sTable, sProperty);
                Grid1.DataSource = dt;
            }
        }

        private void MnPrimaryKey_Click(object sender, EventArgs e)
        {
            setTableProperties("PrimaryKeys");
        }

        private void MnForeignKeys_Click(object sender, EventArgs e)
        {
            setTableProperties("ForeignKeys");  // ok
        }

        private void MnCheckConstraints_Click(object sender, EventArgs e)
        {
            setTableProperties("CheckConstraints");
        }

        private void MnDataTypes_Click(object sender, EventArgs e)
        {
            setTableProperties("DataTypes");  // Ok
        }

        private void MnDomains_Click(object sender, EventArgs e)
        {
            setTableProperties("Domains");
        }

        private void MnGenerators_Click(object sender, EventArgs e)
        {
            setTableProperties("Generators");  // kein fehler, aber auch kein Ergebnis
        }

        private void MnIndexes_Click(object sender, EventArgs e)
        {
            setTableProperties("Indexes"); // Ok
        }

        private void MnProcedures_Click(object sender, EventArgs e)
        {
            setTableProperties("Procedures");
        }

        private void MnTriggers_Click(object sender, EventArgs e)
        {
            setTableProperties("Triggers"); // ok
        }

        private void MnViews_Click(object sender, EventArgs e)
        {
            setTableProperties("Views");
        }

        private void MnInfo_Click(object sender, EventArgs e)
        {
            AboutBox1 frame = new AboutBox1();
            frame.ShowDialog();
        }

        private void BnFontSizeDown_Click(object sender, EventArgs e)
        {
            if (_fontsize > 4)
            {
                _fontsize--;
                splitContainer3.Font = new Font("Microsoft Sans Serif", _fontsize);
                setListBoxSize();
            }

        }
        private void setListBoxSize()
        {
                //Label label1 = new Label();
                //label1.Font = new Font("Microsoft Sans Serif", _fontsize);
                //label1.AutoSize = true;
                LListbox1.Font = new Font("Microsoft Sans Serif", _fontsize);                
                EFontsize.Text = _fontsize.ToString();
                int width=0;
                for (int i = 0; i < listBox1.Items.Count - 1; i++ )
                {
                    LListbox1.Text = (string)listBox1.Items[i];
                    if (LListbox1.Width > width) width = LListbox1.Width;
                }
                Text = width.ToString();
                Text = EFontsize.Width.ToString();
                splitContainer1.SplitterDistance = width + 10;
        }

        private void BnFontSizeUp_Click(object sender, EventArgs e)
        {
            _fontsize++;
            splitContainer3.Font = new Font("Microsoft Sans Serif", _fontsize);
            setListBoxSize();
        }


        private string getFilename()
        {
            string sFilename = "";
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter = "Textdateien (*.txt)|*.txt|Alle Dateien (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".txt";
            saveFileDialog1.InitialDirectory = Environment.CurrentDirectory;
            saveFileDialog1.RestoreDirectory = true;
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                sFilename = saveFileDialog1.FileName.ToString();
                
            }
            return sFilename;
        }
        private void BnSave_Click(object sender, EventArgs e)
        {
            string sFilename = getFilename();
            if (! sFilename.Equals("")) saveFile(sFilename);            
        }

        private void saveFile(string sFilename)
        {
            FileStream oFile = new FileStream(sFilename, FileMode.Create);
            StreamWriter oStream = new StreamWriter(oFile);
            oStream.WriteLine(ESQL.Text);
            oStream.Close();
            oFile.Close();
        }  // SaveFile

        private void MnExportErgebnis_Click(object sender, EventArgs e)
        {
            Clipboard.SetText( getResults() );
        } 


        private void MnSaveErgebnisseToFile_Click(object sender, EventArgs e)
        {
            string sFilename = getFilename();
            if (!sFilename.Equals("")) saveResults2File(sFilename);
        }

        private void saveResults2File(string sFilename)
        {
            String  sErg = getResults();
            FileStream oFile = new FileStream(sFilename, FileMode.Create);
            StreamWriter oStream = new StreamWriter(oFile);
            oStream.WriteLine(sErg);
            oStream.Close();
            oFile.Close();

        }

        private String getResults()
        {
            string sExport = "";
            string sStr;

            // Ablauf mit Zeilen und Spalten, geht von unten nach oben
            for (int col = 0; col < Grid1.ColumnCount; col++)
            {
                sStr = Grid1.Columns[col].HeaderText;
                if (col == 0)
                    sExport = sStr;
                else
                    sExport = sExport + "\t" + sStr;
            }
            for (int row = 0; row < Grid1.RowCount; row++)
            {
                for (int col = 0; col < Grid1.ColumnCount; col++)
                {
                    if (Grid1.Rows[row].Cells[col].Value != null)
                    {
                        sStr = Grid1.Rows[row].Cells[col].Value.ToString();
                        if (col == 0)
                            sExport = sExport + "\r\n" + sStr;
                        else
                            sExport = sExport + "\t" + sStr;

                    }
                }
            }
            return sExport;
        } // getResults



    }
}


//1) ungebundener Modus
//bevorzugt für statische, lokale Daten

//2) gebundener Modus
//bevorzugt für interaktiven Betrieb (schreiben, lesen)
//mit einer Datenbank.

//3) virtueller Modus
//u.a. für grosse Datenmengen.
// this.dataGridView1.VirtualMode = true;

